% Priklad redukce ve stavovem prostoru
% (5 zavazi spojenych pruzinami v rovinnem pohybu)
% ------------------------------------------------

% Inicializace
close all; clear all;
format long;

% Hmotonosti jednotlivych teles
m1 = 3;
m2 = 4.4;
m3 = 1.8;
m4 = 6.1;
m5 = 50;

% Tuhost spojujicich pruziny
k12 = 456;
k23 = 673;
k34 = 276;
k45 = 700;

% pom??n????lumy
br=[0.01 0.01 0.01 0.01 0.01];

% Model systemu M*ddx + B*dx + Kx = f
% Matice hmotnosti
M=[m1  0   0   0  0
   0  m2   0   0  0
   0   0  m3   0  0
   0   0   0  m4  0
   0   0   0   0  m5];
% Matice tuhosti 
K=[ k12     -k12       0       0          0
   -k12    k12+k23   -k23      0          0
     0      -k23    k23+k34   -k34        0  
     0        0       -k34     k34+k45  -k45 
     0        0        0        -k45     k45];
 
%%
     
 % Modalni analyza systemu
 
 % Vlastni uhlove frekvence

 % "tuhy" vlastni tvar
 
 % Matice hmotnosti pro pohyb tuheho telesa

 % Projekcni matice 
 % (promita pusobeni vnejsich sil na poddajne mody)
 
 % teleso m1 pevne ulozime, spocitame matici poddajnosti ulozene soustavy

 % Matici poddajnosti doplnime nulami
 
 % Redukce popisu systemu
 % PO REDDUKCI PONECHAME PRVNI DVA ELASTICKE TVARY + TUHY TVAR

 D = R;

 %%
 
 % Stavovy popis redukovany 
A = [0 1 0 0 0 0;
     zeros(1,6);
     0 0 0  Omeg(2)  0 0; 
     0 0 -Omeg(2) -2*br(2)*Omeg(2)  0 0; 
     0 0  0 0 0  Omeg(3);
     0 0  0 0 -Omeg(3) -2*br(3)*Omeg(3)];
B = [zeros(1,5);
     inv(miir)*Vr'; 
     zeros(1,5);
     (V(:,2))';
     zeros(1,5);
     (V(:,3))'];
C = [Vr zeros(5,1) V(:,2)/Omeg(2) zeros(5,1) V(:,3)/Omeg(3) zeros(5,1)];

% prenos od sily F1 na vychylku x1
[NUM1,DEN1] = ss2tf(A,B(:,1),C(1,:),D(1,1));
% podobne muzeme zkouset dalsi prenosy
% [NUM1,DEN1] = ss2tf(A,B(:,2),C(3,:),D(3,2)); 
% Takto napr sila z 2 na pohyb 3 atd...
ff = 0.1:0.001:6;
om = ff*2*pi;
s  = sqrt(-1)*om;
NUMERATOR = polyval(NUM1,s);
DENOMINATOR = polyval(DEN1,s);
Trans_model = NUMERATOR./(DENOMINATOR);

% Zobrazeni prenosu
figure(1);
plot(ff,abs(Trans_model),'b'),grid on, hold on;
figure(2);
plot(ff,angle(Trans_model),'b'),grid on, hold on;
figure(3);
plot(real(Trans_model),imag(Trans_model),'b'),grid on, hold on;

%%

% Vypocet pro neredukovany model s 5 telesy
A_full = [0 1 zeros(1,8);
    zeros(1,10);
    0 0 0  Omeg(2)  zeros(1,6);
    0 0 -Omeg(2) -2*br(2)*Omeg(2)  zeros(1,6);
    zeros(1,4)  0  Omeg(3) zeros(1,4);
    zeros(1,4)  -Omeg(3) -2*br(3)*Omeg(3) zeros(1,4);
    zeros(1,6)  0  Omeg(4) 0 0;
    zeros(1,6)  -Omeg(4) -2*br(4)*Omeg(4) 0 0;
    zeros(1,8)  0  Omeg(5);
    zeros(1,8)  -Omeg(5) -2*br(5)*Omeg(5)];
B_full = [zeros(1,5);
    inv(miir)*Vr';
    zeros(1,5);
    (V(:,2))';
    zeros(1,5);
    (V(:,3))';
    zeros(1,5);
    (V(:,4))';
    zeros(1,5);
    (V(:,5))'];

C_full = [Vr zeros(5,1) V(:,2)/Omeg(2) zeros(5,1) V(:,3)/Omeg(3) zeros(5,1) ...
          V(:,4)/Omeg(4) zeros(5,1) V(:,5)/Omeg(5) zeros(5,1)];
D_full = zeros(size(D)); 
 
[NUM1,DEN1] = ss2tf(A_full,B_full(:,1),C_full(1,:),D_full(1,1));

ff = 0.1:0.001:6;
om = ff*2*pi;
s = sqrt(-1)*om;
NUMERATOR = polyval(NUM1,s);
DENOMINATOR = polyval(DEN1,s);
Trans_model = NUMERATOR./(DENOMINATOR);

% Porovnani prenosu
figure(1);
plot(ff,abs(Trans_model),'r'),grid on, hold on;
figure(2);
plot(ff,angle(Trans_model),'r'),grid on, hold on;
figure(3);
plot(real(Trans_model),imag(Trans_model),'r'),grid on, hold on;

% Zobrazeni vlastnich tvaru
figure;
plot(V,'d-');
grid on;
legend('rigid mode','1. elastic mode','2. elastic mode','3. elastic mode','4. elastic mode') ;
 
